//sderror.h - Standard SmartDisk Error Codes (Someday)
//
// Someday this will become the standard SmartDisk error codes.
// Initially they are for FlashPath drivers only.
//
// $Log: SDError.h,v $
// Revision 1.4  2000/03/10 19:08:35  gus
// Changed status reporting system - works better now
//
//Revision 1.3  2000/03/06 22:09:36  gus
//Updated to most recent SmartDisk library
//
//Revision 1.2  2000/01/27 22:32:24  jmcmulla
//Initial Linux Port
//
//   
//      Rev 1000.4   Jan 17 2000 11:19:26   larryplib
//   01/13/2000 changes from RJM.
 // 
 //    Rev 1000.3   Oct 29 1999 13:37:22   larryplib
 // USB AND WINDOWS 2000 SUPPORT 10-29-1999
 //    Rev 1000.2   Oct 27 1999 19:22:06   larryplib
 //    10/27/99 USB SUBMIT BY RJM 
 // 
 //    Rev 1000.1   Oct 11 1999 14:09:32   larryplib
 // VM 6.5: moved workfiles from old SRC (old VM 6.0 library)
//
//   Rev 2.7   Aug 23 1999 11:00:44   larryplib
// 
// BLS 8/20/99 Added SDE_DEF_BLOCK_ALL_IO
//
//   Rev 2.6   Aug 13 1999 17:33:16   larryplib
// 
//
//   Rev 2.5   Aug 10 1999 19:31:46   larryplib
// 
//
//   Rev 2.4   Jun 24 1999 15:04:14   larryplib
// 
//
//   Rev 2.3   Jun 24 1999 14:43:54   larryplib
// 
// BLS 6/24/99 Added SDE_DEF_MEDIA_TOO_LARGE_FOR_DEVICE
//
//   Rev 2.2   Jun 23 1999 11:51:58   larryplib
// 
// BLS 6/18/99 Added SDE_FP_FIRMWARE_BATTERY_LOW and move define around
//
//   Rev 2.1   Jun 17 1999 16:19:20   larryplib
// 
// BLS 6/2/99 Added several new error define
//
//   Rev 2.0   May 21 1999 10:56:36   larryplib
// 
//
//   Rev 1.6   May 21 1999 10:23:00   larryplib
// 
//
//   Rev 1.5   May 11 1999 11:43:06   larryplib
//            05/10/1999 changes by RLM for PC/SC
//                               support (NT40)
//
// RJM 5/10/99 added SDE_UNSUPPORTED_FUNCTION
//
//   Rev 1.4   May 10 1999 17:39:28   larryplib
//            5/10/99 changes by RJM for Flashms support
//
/* RJM 5/4/99 added new Memory Stick firmwarea error codes
 * 
 *    Rev 1.3   Apr 01 1999 01:05:10   larryplib
 * From:Randy.Martin@FISCVM
 * Date:Wednesday, 31 March 1999 5:55pm ET
 * To:Benoit.Legris,Larry.Larimer
 * Cc:
 * Subject:Library submission
 * Topic:
 * 
 * 
 * I have submitted the following things to the library:
 * 
 * fromrjm\sddev\src - sources modified to support PC/SC NT and Flash9x
 * 
 * fromrjm\drivers\nt4\sdselect - the latest sdselect sources and executables for
 * PC/SC
 * fromrjm\flash\nt4\flashnt - the latest flashnt executables updated to be in
 * sync with SDSelect changes
 * fromrjm\drivers\w9x\sdselect - the latest sdselect for Windows 95/98 sources
 * and executables
 * fromrjm\drivers\w9x\flash9x - the latest flash9x sources and executables for
 * 128 MB support.
 * fromrjm\inc - include file updates that correspond to the other changes above.
 * 
 * Note: Since the previous submissions had not been checked into the library,
 * these changes include some files that are already submitted.
 * 
 * The W9x files may represent the beta versions of Flash9x
 * 
 * Randy Martin
 * Senior Software Developer
 * SmartDisk Corporation
 * 
 * 
 *    Rev 1.2   Feb 19 1999 09:47:08   benoitplib
 *  
 * 
 *    Rev 1.1   Feb 11 1999 17:43:20   larryplib
 *  
 * BLS 2/8/99 Added SDE_SDSELECT_NOT_PRESENT, SDE_SDSELECT_NO_DRIVE, SDE_UNABLE_TO_OPEN, SDE_INPUT_EMPTY
 *			SDE_READ_ERROR, SDE_FILE_TOO_SMALL, SDE_BLOCK_NUM_TO_LOW and their defines
 * 
 *    Rev 1.0   Jan 19 1999 11:37:46   benoitplib
 *  
 * 
 *    Rev 1.2   Jan 19 1999 11:35:00   benoitplib
 *  
 * RJM 1/15/99 added SDE_SDSELECT_NO_DRIVE,				// Drive not filtered
 * 
 *    Rev 1.1   Nov 24 1998 16:54:44   benoitplib
 */  
// 
//    Rev 1.0   Nov 24 1998 13:57:54   benoitplib
// Checked in from initial workfile by PVCS Version Manager Project Assistant.
// * 
// *    Rev 1.0   Oct 21 1998 15:03:00   benoitplib
// *
// 
//    Rev 1.4   28 Oct 1998 15:55:10   Randy
// 
//    Rev 1.3   15 Oct 1998 12:12:48   Randy
// BLS 9/28/98 Added SDE_INVALID_HANDLE and all defines for strings
// 
//    Rev 1.1   03 Sep 1998 09:39:54   Randy
// 
//    Rev 1.0   25 Aug 1998 18:27:12   Randy
// Initial revision.
// 
//    Rev 1.0   24 Aug 1998 10:57:26   Randy
// Initial revision.
// 
//    Rev 1.5   17 Aug 1998 10:01:22   Randy
// Added SDE_MEDIA_FULL and SDE_INTERNAL_ERROR
// 
//    Rev 1.4   10 Aug 1998 08:52:56   Randy
// Added a range of error codes for FlashPath firmware errors
// Added codes for remap errors
// 
//    Rev 1.3   04 Aug 1998 17:58:56   Randy
// I added an error code: SDE_DEVICE_POWERED_OFF
// 
//    Rev 1.2   24 Jul 1998 15:15:46   Randy
// 
//    Rev 1.1   22 Jul 1998 14:11:12   Randy
// 
//    Rev 1.0   13 Jul 1998 15:20:00   Randy
// Initial revision.
//

#ifndef __sderror_h__
#define __sderror_h__

typedef enum
{
	// General codes
	SDE_SUCCESS,
	SDE_UNKNOWN_ERROR,				// Can not identify error
	SDE_BUFFER_TOO_SMALL,
	SDE_NOT_FOUND,
	SDE_INTERNAL_ERROR,				// You should never get this code, unless..
	SDE_INCOMPATIBLE_VERSION,		// The version of is not compatible
	SDE_INSUFFICIENT_MEMORY,			// Unable to allocate memory
	SDE_INVALID_PARAMETER,			// Invalid parameter
	SDE_INVALID_HANDLE,				// Invalid handle
	SDE_SHARING_VIOLATION,			// File sharing violation
	SDE_IO_PENDING,					// Input/ouput pending
	SDE_UNABLE_TO_OPEN,				// Unable to open file
	SDE_INPUT_EMPTY,				// File empty
	SDE_READ_ERROR,					// Read error
	SDE_FILE_TOO_SMALL,				// File too small
	SDE_UNSUPPORTED_FUNCTION,		// The requested function is not supported
	SDE_FILE_NOT_FOUND,				// The requested file does not exist
	SDE_WRITE_READ_MISMATCH,		// Write read buffers did not compare
	SDE_FIRMWARE_BATTERY_LOW,		// FlashPath battery are low

	// FlashPath Firmware errors.
	// These may need to be moved somewhere else
	SDE_FP_FIRMWARE_WRITE_BLOCK = 0xA0,	// Error writing block to flash
	SDE_FP_FIRMWARE_READ_BLOCK,			// Error reading a block
	SDE_FP_FIRMWARE_ERASE_BLOCK,		// Error erasing a flash block
	SDE_FP_FIRMWARE_CRC_FAILURE,		// CRC over received data incorrect
	SDE_FP_FIRMWARE_INVALID_SERVICE,	// Service code incorrect
	SDE_FP_FIRMWARE_READ_TAIL,			// Error reading tail
	SDE_FP_FIRMWARE_WRITE_TAIL,			// Error writing tail
	SDE_FP_FIRMWARE_DATA_CHECKSUM,		// Checksum over all data failed
	SDE_FP_FIRMWARE_FLASH_TIMEOUT = 0xAB,// Timeout on flash ready/busy line
	SDE_FP_FIRMWARE_BLOCK_WRITES = 0xAE,// Battery is low so writes are prevented
	SDE_FP_FIRMWARE_INVALID_DEVICE,		// Flash device type invalid or not initialized
	SDE_FP_FIRMWARE_INPUT_TIMEOUT,
	SDE_FP_FIRMWARE_CRC_MISMATCH,
	SDE_FP_FIRMWARE_FLASH_ERROR,		// Usually media incorrectly inserted.
	SDE_FP_FIRMWARE_DEVICE_PROTOCOL,
	SDE_FP_FIRMWARE_DEVICE_CRC,
	SDE_FP_FIRMWARE_MS_COMMAND_NAK = 0xC0,// Memory Stick command NAK
	SDE_FP_FIRMWARE_MS_NO_STATUS,		// Could not obtain Memory Stick status
	SDE_FP_FIRMWARE_MS_WRITE_PROTECT,	// The Memory Stick is locked
	SDE_FP_FIRMWARE_MS_NOT_INSERTED,	// No Memory Stick inserted into FlashPath 

	// FloppyDrive
	SDE_MEDIA_CHANGE_DETECTED = 0x1000,
	SDE_SECTOR_NOT_FOUND,
	SDE_DEVICE_POWERED_OFF,
	SDE_NO_MEDIA_IN_DEVICE,
	SDE_MEDIA_WRITE_PROTECTED,
	SDE_INVALID_DEVICE_REQUEST,
	SDE_CRC_ERROR,						// May be returned by the O/S
	SDE_NOT_SUPPORTED,

	// FlashPath
	SDE_FP_NO_FLASHPATH = 0x2000,
	SDE_FP_INPUT_ERROR,
	SDE_COPY_PROTECTED_DATA,
	SDE_BLOCK_ALL_IO,

	// FlashMedia
	SDE_READ_BEYOND_END_OF_MEDIA = 0x3000,
	SDE_WRITE_BEYOND_END_OF_MEDIA,
	SDE_INVALID_MEDIA_FORMAT,			// The CIS could not be found
	SDE_UNSUPPORTED_MEDIA,				// This media is not supported by driver
	SDE_REMAPPED_BLOCK,					// A new block was assigned due to flash error
	SDE_REMAP_FAILED,					// Unable to remap block
	SDE_MEDIA_FULL,						// Unable to map a new flash block, probably full
	SDE_BLOCK_NUM_TO_LOW,				// The block to process is smaller than the first available block
	SDE_NO_FLASHMEDIA_IN_DEVICE,		// No media has been inserted into the device
	SDE_MEDIA_TOO_LARGE_FOR_DEVICE,		// Media size exeeds capability of FlashPath
	SDE_INVALID_LBA,					// The LBA is not valid.
	SDE_ERASE_UNRELIABLE,				// The erase did not reliably clear flash

	// VirtualFloppy
	SDE_INVALID_LOGICAL_FORMAT = 0x4000, 	// Media not formatted properly
	SDE_UNSUPPORTED_MEDIA_SIZE,

	// Ecc error codes
	SDE_ECC_DATA_CORRECTED	= 0x5000,	// A correctable data error occured
	SDE_ECC_CORRECTED,					// A correctable ECC error occured
	SDE_ECC_ERROR,						// An uncorrectable ECC error occured

	// SDSelect error codes
	SDE_TOO_MANY_REGISTRANTS = 0X6000,	// Too many programs have registered
	SDE_TOO_MANY_PRODUCTS,				// The maximum products are identified
	SDE_INCOMPATIBLE_SDSELECT_VERSION,	// The version of SDSelect is not compatible
	SDE_INVALID_API_HANDLE,				// API handle is not currently valid
	SDE_PRODUCT_CHANGE_DETECTED,		// A different product type was inserted
	SDE_SDSELECT_NOT_PRESENT,			// SDSelect has not been found
	SDE_SDSELECT_NO_DRIVE,				// Drive not filtered

	// FlashPath API error codes
	SDE_INVALID_EVENT_HANDLE	= 0x7000,	// Event handle passed to driver is invalid
	SDE_NOTIFICATION_REJECTED,				// No one registered to handle notifications
	SDE_NOT_REGISTERED,						// No one is registered to retrieve notes
	SDE_INCOMPATIBLE_FPAPI_VERSION,

	SDE_MAXIMUM_ERROR_CODE = 0xffffffff		// Used to mark the end of the enum.
} SDERROR;

#define 	SDE_DEF_SUCCESS                     10000
#define 	SDE_DEF_UNKNOWN_ERROR               10001
#define 	SDE_DEF_BUFFER_TOO_SMALL			10002
#define 	SDE_DEF_NOT_FOUND                   10003
#define 	SDE_DEF_INTERNAL_ERROR              10004
#define 	SDE_DEF_INCOMPATIBLE_VERSION		10005
#define 	SDE_DEF_INSUFFICIENT_MEMORY			10006
#define 	SDE_DEF_INVALID_PARAMETER			10007
#define 	SDE_DEF_INVALID_HANDLE				10008
#define		SDE_DEF_SHARING_VIOLATION			10009
#define		SDE_DEF_IO_PENDING	  				10010
#define		SDE_DEF_UNABLE_TO_OPEN				10011
#define		SDE_DEF_INPUT_EMPTY					10012
#define		SDE_DEF_READ_ERROR					10013
#define		SDE_DEF_FILE_TOO_SMALL				10014
#define		SDE_DEF_UNSUPPORTED_FUNCTION		10015
#define		SDE_DEF_FILE_NOT_FOUND				10016
#define		SDE_DEF_WRITE_READ_MISMATCH			10017
#define 	SDE_DEF_FIRMWARE_BATTERY_LOW		10018


	// FlashPath Firmware errors.
	// These may need to be moved somewhere else
#define 	SDE_DEF_FP_FIRMWARE_WRITE_BLOCK		10160
#define 	SDE_DEF_FP_FIRMWARE_READ_BLOCK		10161
#define 	SDE_DEF_FP_FIRMWARE_ERASE_BLOCK		10162
#define 	SDE_DEF_FP_FIRMWARE_CRC_FAILURE		10163
#define 	SDE_DEF_FP_FIRMWARE_INVALID_SERVICE	10164
#define 	SDE_DEF_FP_FIRMWARE_READ_TAIL		10165
#define 	SDE_DEF_FP_FIRMWARE_WRITE_TAIL		10166
#define 	SDE_DEF_FP_FIRMWARE_DATA_CHECKSUM	10167
#define 	SDE_DEF_FP_FIRMWARE_FLASH_TIMEOUT	10171
#define 	SDE_DEF_FP_FIRMWARE_BLOCK_WRITES	10174
#define		SDE_DEF_FP_FIRMWARE_INVALID_DEVICE	10175
#define 	SDE_DEF_FP_FIRMWARE_INPUT_TIMEOUT	10176
#define 	SDE_DEF_FP_FIRMWARE_CRC_MISMATCH	10177
#define 	SDE_DEF_FP_FIRMWARE_FLASH_ERROR		10178
#define 	SDE_DEF_FP_FIRMWARE_DEVICE_PROTOCOL	10179
#define 	SDE_DEF_FP_FIRMWARE_DEVICE_CRC		10180
#define 	SDE_DEF_FP_FIRMWARE_MS_COMMAND_NAK	10181
#define 	SDE_DEF_FP_FIRMWARE_MS_NO_STATUS	10182
#define 	SDE_DEF_FP_FIRMWARE_MS_WRITE_PROTECT	10183
#define 	SDE_DEF_FP_FIRMWARE_MS_NOT_INSERTED	10184

	// FloppyDrive
#define 	SDE_DEF_MEDIA_CHANGE_DETECTED		14096
#define 	SDE_DEF_SECTOR_NOT_FOUND			14097
#define 	SDE_DEF_DEVICE_POWERED_OFF			14098
#define 	SDE_DEF_NO_MEDIA_IN_DEVICE			14099
#define 	SDE_DEF_MEDIA_WRITE_PROTECTED		14100
#define 	SDE_DEF_INVALID_DEVICE_REQUEST		14101
#define 	SDE_DEF_CRC_ERROR					14102
#define     SDE_DEF_NOT_SUPPORTED               14103

	// FlashPath
#define 	SDE_DEF_FP_NO_FLASHPATH				18192
#define 	SDE_DEF_FP_INPUT_ERROR				18193
#define		SDE_DEF_COPY_PROTECTED_DATA			18194
#define		SDE_DEF_BLOCK_ALL_IO				18195

	// SmartMedia
#define 	SDE_DEF_READ_BEYOND_END_OF_MEDIA 	22288
#define 	SDE_DEF_WRITE_BEYOND_END_OF_MEDIA	22289
#define 	SDE_DEF_INVALID_MEDIA_FORMAT		22290
#define 	SDE_DEF_UNSUPPORTED_MEDIA			22291
#define 	SDE_DEF_REMAPPED_BLOCK				22292
#define 	SDE_DEF_REMAP_FAILED				22293
#define 	SDE_DEF_MEDIA_FULL					22294
#define		SDE_DEF_BLOCK_NUM_TO_LOW			22295
#define		SDE_DEF_NO_FLASHMEDIA_IN_DEVICE		22296
#define		SDE_DEF_MEDIA_TOO_LARGE_FOR_DEVICE	22297

	// VirtualFloppy
#define 	SDE_DEF_INVALID_LOGICAL_FORMAT		26384
#define 	SDE_DEF_UNSUPPORTED_MEDIA_SIZE		26385

	// Ecc error codes
#define 	SDE_DEF_ECC_DATA_CORRECTED			30480
#define 	SDE_DEF_ECC_CORRECTED				30481
#define 	SDE_DEF_ECC_ERROR					30482

	// SDSelect error codes
#define 	SDE_DEF_TOO_MANY_REGISTRANTS		34576
#define 	SDE_DEF_TOO_MANY_PRODUCTS			34577
#define 	SDE_DEF_INCOMPATIBLE_SDSELECT_VERSION	34578
#define 	SDE_DEF_INVALID_API_HANDLE			34579
#define 	SDE_DEF_PRODUCT_CHANGE_DETECTED		34580
#define		SDE_DEF_SDSELECT_NOT_PRESENT		34581
#define		SDE_DEF_SDSELECT_NO_DRIVE			34582

	// FlashPath API error codes
#define 	SDE_DEF_INVALID_EVENT_HANDLE		38672
#define 	SDE_DEF_NOTIFICATION_REJECTED		38673
#define 	SDE_DEF_NOT_REGISTERED				38674

#define 	SDE_DEF_MAXIMUM_ERROR_CODE			38675

#define 	TEN_THOUSAND						10000

#endif //__sderror_h__
