/* Jason McMullan	<jmcmullan@linuxcare.com>
 * Common headers
 * $Revision: 1.14 $
 *
 * $Log: sdlnx.h,v $
 * Revision 1.14  2000/04/14 13:49:17  gus
 * Corel fixes
 *
 * Revision 1.13  2000/03/10 19:08:35  gus
 * Changed status reporting system - works better now
 *
 * Revision 1.12  2000/03/06 22:08:40  gus
 * Fixed the normal-user-cant-use-mtools bug
 *
 * Revision 1.11  2000/02/27 05:34:31  gus
 * Ahh.. Final fixes...
 *
 * Revision 1.10  2000/02/25 22:41:45  gus
 * Forgout about the duplicate inode issue...
 *
 * Revision 1.9  2000/02/24 09:51:15  gus
 * ALPHA Release. This has a working fpdaemon implementation, and a
 * 	working driver implementation. Yee ha.
 *
 * Revision 1.8  2000/02/21 23:21:53  gus
 * Finally got the floppy_raw_cmd based IO working, and it works like
 * a dream! Now performing some tests to make sure I didn't screw something up.
 *
 * Revision 1.7  2000/02/18 22:55:33  jmcc
 * Latest rev - includes all 3 types of IO, but seems to kill the
 * buffer system on too many writes...
 *
 * Revision 1.6  2000/02/17 20:14:22  jmcc
 * Change: Use inode mangler
 *
 * Revision 1.5  2000/02/16 16:57:15  jmcc
 * Autoamatically changes to the FlashPath major if a FlashPath is
 * inserted into /dev/fd0
 *
 */

#ifndef _FP_LINUX_H_
#define _FP_LINUX_H_

/* Define to make the FlashPath a read-only device.
 */
/* #define FP_READONLY */

/* Define the max timeout (in jiffies) before manglement ends
 * after a close(2). Default is 5 seconds
 */
#define FP_INODE_MANGLE_TIMEOUT		5*HZ

/* Maximum number of tries before we give up on a sleepy disk.
 */
#define FP_SLEEP_TRIES	3

/* Which type of IO code do you want to test?
 * !!! PLEASE read the DESIGN document before changing this!!!!
 */
#define FP_IO_READWRITE	1	/* f_op->read()/f_op->write() */
#define FP_IO_BLOCK	2		/* buffer header interface */
#define FP_IO_RAW	3		/* FD raw command interface */
#define FP_IO_MODE	FP_IO_RAW

#include <linux/module.h>
#ifdef MODVERSIONS
#include <linux/modversions.h>
#endif
#include <linux/kernel.h>
#include <linux/types.h>
#include "sdgen.h"

#define DEVICE_NAME "flashpath"

extern int flashpath_major;
extern struct file_operations *fd_fops_ptr,fd_fops_old;

#ifdef DBG_MEMORY
extern void cppfake_status(void);
#endif
#ifdef DBG
#define DPRINT(fmt,arg...)	\
	do { 	printk(KERN_DEBUG DEVICE_NAME ": " fmt, ##arg ); \
		printk(KERN_DEBUG DEVICE_NAME ":   at %s:%d\n",__FILE__,__LINE__); \
	} while (0) 
#else
#define DPRINT(fmt,arg...)
#endif

#endif // _FP_LINUX_H_
